package com.example.client;

import java.util.ArrayList;
import java.util.List;

import com.example.client.widgets.WidgetMultiline;
import com.example.shared.SimpleData;
import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.user.client.ui.IsWidget;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.Widget;
import com.sencha.gxt.core.client.util.Format;
import com.sencha.gxt.core.client.util.Margins;
import com.sencha.gxt.widget.core.client.ContentPanel;
import com.sencha.gxt.widget.core.client.container.VerticalLayoutContainer;
import com.sencha.gxt.widget.core.client.container.VerticalLayoutContainer.VerticalLayoutData;

public class Gxt_widget implements IsWidget, EntryPoint
{
	WidgetMultiline tas1;
	WidgetMultiline tas2;
	
	private final String TEMPLATE = "<span style=\"font-size:16px;font-family:'Times New Roman',Tahoma,Georgia;\">{0}</span>"; 

	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	private void createComponents()
	{
		List<SimpleData> list1 = new ArrayList<SimpleData>();
		list1.add(new SimpleData(1, "Футбол"          ));
		list1.add(new SimpleData(2, "Хоккей"          ));
		list1.add(new SimpleData(3, "Лыжи"            ));
		list1.add(new SimpleData(4, "Легкая атлетика" ));
		list1.add(new SimpleData(5, "Тяжелая атлетика"));

		List<SimpleData> list2 = new ArrayList<SimpleData>();
		list2.add(new SimpleData(1, "Музыкальная школа"      ));
		list2.add(new SimpleData(2, "Шахматный кружок"       ));
		list2.add(new SimpleData(3, "Школа игры на гитаре"   ));
		list2.add(new SimpleData(4, "Хореографический кружок"));

		tas1 = new WidgetMultiline(48);
		
		tas1.setReadOnly(true);
		tas1.setEmptyText("Выберите секции ...");
		tas1.setAllowBlank(false);

		tas2 = new WidgetMultiline();
		tas2.setWidgetWidth(300);

		tas1.setList(list1);
		tas2.setList(list2);
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	@Override
	public Widget asWidget()
	{
		ContentPanel panel = new ContentPanel();
		panel.setHeadingText("GWT-GXT Toolbar");
		panel.setPixelSize(400, 240);
		panel.addStyleName("margin-5");
		panel.getHeader().setHTML(Format.substitute(TEMPLATE, "GWT-GXT Toolbar"));
	   
		VerticalLayoutContainer vlc = new VerticalLayoutContainer();
		vlc.setBorders(true);
		vlc.getElement().getStyle().setBackgroundColor("white"); 

		createComponents();
		vlc.add(tas1, new VerticalLayoutData( 1, -1, new Margins(24, 6, 0, 6)));
		vlc.add(tas2, new VerticalLayoutData(-1, -1, new Margins(6, 0, 0, 6)));
		
		panel.add(vlc);
		return panel;
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	/**
	 * This is the entry point method.
	 */
	public void onModuleLoad()
	{
		RootPanel.get("wrapper").add(asWidget());
	}
}
