package com.example.client.widgets;

import java.util.ArrayList;
import java.util.List;

import com.example.shared.SimpleData;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.user.client.ui.IsWidget;
import com.sencha.gxt.core.client.util.Margins;
import com.sencha.gxt.widget.core.client.form.TextArea;
import com.sencha.gxt.widget.core.client.button.TextButton;
import com.sencha.gxt.widget.core.client.event.SelectEvent;
import com.sencha.gxt.widget.core.client.event.SelectEvent.SelectHandler;
import com.sencha.gxt.widget.core.client.container.HorizontalLayoutContainer;
import com.sencha.gxt.widget.core.client.container.HorizontalLayoutContainer.HorizontalLayoutData;

public class WidgetMultiline implements IsWidget
{
	private  TextArea                   text     = null;
	private  TextButton                 button   = null;
	private  int                        height   =   32;
	private  GridMultiLineChooser       chooser  = null;
	private  List<SimpleData>           list     = null;
	private  HorizontalLayoutContainer  hlc      = null;
	
	public WidgetMultiline()
	{
		hlc = new HorizontalLayoutContainer();
		hlc.setHeight(height);
		
		createGUI();
		list = new ArrayList<SimpleData> ();
	}
	public WidgetMultiline(final int height)
	{
		this();
		hlc.setHeight(height);
		button.setPixelSize(20, height);
	}
	@Override
	public Widget asWidget()
	{
		return hlc;
	}
	private void createGUI()
	{
		text = new TextArea();
		
		button = new TextButton("...");
		button.setPixelSize(20, height);
		
        Margins margins = new Margins(0, 1, 0, 0);
        hlc.add(text  , new HorizontalLayoutData( 1, 1, margins));
        margins = new Margins(0, 0, 0,-3);
        hlc.add(button, new HorizontalLayoutData(-1,-1, margins));
		
        chooser = new GridMultiLineChooser(this);
        button.addSelectHandler(new SelectHandler(){
			@Override
			public void onSelect(SelectEvent se) {
				chooser.show();
			}
		});
	}
	public void setEmptyText(final String emptyText)
	{
		text.setEmptyText(emptyText);
		
	}
	public void setReadOnly(final boolean mode)
	{
		text.setReadOnly(mode);
	}
	public void setAllowBlank(final boolean mode)
	{
		text.setAllowBlank(mode);
		
	}
	public void setWidgetWidth(final int width)
	{
		hlc.setWidth(width);
		hlc.forceLayout();
	}
	public String getText()
	{
		return text.getText(); 
	}
	public void setList(List<SimpleData> data)
	{
		list.clear();
		if ((data != null) && !data.isEmpty())
			this.list.addAll(data);
		chooser.setList(list);
	}	
	public List<SimpleData> getSelected()
	{
		List<SimpleData> selected = new ArrayList<SimpleData>();
		for (SimpleData rec : list) {
			if (rec.getSelected())
				selected.add(rec);
		}
		return selected;
	}
	public void selectionHandler()
	{
		String temp = "";
		if (list.size() > 0) {
			for (SimpleData rec : list) {
				if (rec.getSelected()) {
					if (temp.length() > 0)
						temp += ", ";
					temp += rec.getLabel();
				}
			}
		}
		this.text.setText(temp);
	}
}
